  {
   Include-bett a mindenfle inputfile generlshoz,
       (pl. Hash-kdols kiprblshoz:
        egy tblzathoz, amelynek kulcsa teljes magyar szemly nevek)
   Exportfogalmak:
       Type     TNev           = NvTpus
       Function RandomNev      = a kvetkez vletlen magyar nv
       Function RandomCim      = a kvetkez vletlen magyar cm
       Function RandomTel      = a kvetkez vletlen magyar telefonszm
       Function RandomSzemSzam = a kvetkez vletlen szemlyi szm
       Var      noE:Boolean    = az utolsknt generlt nv n-e
  }
  Const
    M=40; {max. nvhossz}
  Type
    TNev = String[M];
  Var
    noE : Boolean; {az utolsonak generalt nev nohoz tartozik-e}

  Function RandomNev: TNev;
    {a telefonknyv alapjn sszeszedett nevek:}
    Const
      MV = 55; {sszes vezetknv}
      MKL= 20; MKF= 38; MK = MKL+MKF; {leny-, fi- s sszes keresztnv}
      R  = 7/50; {n=7} r2 = 0.2; {Valamin X Y fajtj nv}
      Vezetek : Array [1..MV] of TNev=
                ('Nagy','Malgot','Timk','Micu','Vrnai',
                 'Lukcs','Nyoszoli','Lzr','Simk','Sfalvy',
                 'Vradi','Chk','Krpti','Fekete','Dadi',
                 'Kormos','Farkas','Czipot','Egri','Kima',
                 'Barna','Apk','Balzs','Bor','Bujtor',
                 'Bukovszky','Gspr','Jaszovszky','Ivacs','Kvi',
                 'Kulik','Borsos','Daku','l','Flanek',
                 'Fldi','Farkas','Altai','Avar','Bradics',
                 'Majda','Pallos','Sebestyn','Szekeres','Sznyi',
                 'Vasi','Major','Mhi','Srvri','Szatmri',
                 'dn','Tk','rmi','ron','kos');
      Kereszt : Array [1..MK] of TNev= {ell vannak, MKL-ig a lenynevek}
                ('gota','Erika','Jlia','Andrea','Enik',
                 'va','Zsuzsanna','Margit','gnes','Nra',
                 'Anna','Katalin','Gabriella','Irma','Anik',
                 'gnes','Kamilla','va','Tnde','Katalin',
                 'Dezs','Sndor','Gyula','Kroly','Ern',
                 'Elemr','Gbor','Ferenc','Jzsef','Istvn',
                 'Aladr','Gbor','Gyula','Emil','Mikls',
                 'Jzsef','Lajos','Gyula','Jzsef','Endre',
                 'Ferenc','Gyrgy','Attila','Pl','Antal',
                 'Ott','Jnos','Sndor','Lajos','Lszl',
                 'Istvn','Klmn','Bla','Jzsef','Ferenc',
                 'dn','ron','kos');
    Var
      iV,iK: Integer;  nev: TNev;
  Begin
    iV:=Random(MV)+1; nev:=Vezetek[iV];
    If Random<r then {asszonynv}
    Begin
      noE:=True; {Igen, holgy}
      If Random<r2 then
      Begin
        iV:=Random(MV)+1; iK:=Random(MKL)+1;
        RandomNev:=nev+'n '+Vezetek[iV]+' '+Kereszt[iK];
      End
         Else
      Begin
        iK:=MKL+1+Random(MKF);
        RandomNev:=nev+' '+Kereszt[iK]+'n';
      End
    End
       Else          {fi- vagy lenynv}
    Begin
      iK:=Random(MK)+1;
      noE:=iK<MKL; {lany-e}
      RandomNev:=nev+' '+Kereszt[iK];
    End;
  End;

  Function RandomCim: TNev;
    Const
      MV = 55; {sszes vezetknv}
      MKL= 20; MKF= 38; MK = MKL+MKF;
      Vezetek : Array [1..MV+Mk] of TNev=
                ('Nagy','Malgot','Timk','Micu','Vrnai',
                 'Lukcs','Nyoszoli','Lzr','Simk','Sfalvy',
                 'Vradi','Chk','Krpti','Fekete','Dadi',
                 'Kormos','Farkas','Czipot','Egri','Kima',
                 'Barna','Apk','Balzs','Bor','Bujtor',
                 'Bukovszky','Gspr','Jaszovszky','Ivacs','Kvi',
                 'Kulik','Borsos','Daku','l','Flanek',
                 'Fldi','Farkas','Altai','Avar','Bradics',
                 'Majda','Pallos','Sebestyn','Szekeres','Sznyi',
                 'Vasi','Major','Mhi','Srvri','Szatmri',
                 'dn','Tk','rmi','ron','kos',
                 'gota','Erika','Jlia','Andrea','Enik',
                 'va','Zsuzsanna','Margit','gnes','Nra',
                 'Anna','Katalin','Gabriella','Irma','Anik',
                 'gnes','Kamilla','va','Tnde','Katalin',
                 'Dezs','Sndor','Gyula','Kroly','Ern',
                 'Elemr','Gbor','Ferenc','Jzsef','Istvn',
                 'Aladr','Gbor','Gyula','Emil','Mikls',
                 'Jzsef','Lajos','Gyula','Jzsef','Endre',
                 'Ferenc','Gyrgy','Attila','Pl','Antal',
                 'Ott','Jnos','Sndor','Lajos','Lszl',
                 'Istvn','Klmn','Bla','Jzsef','Ferenc',
                 'dn','ron','kos');
    Type
      TFajta=(ut,utca,krt,ter,dulo);
    Const
      MaxFajta=Ord(dulo);
      Fajtak:Array [0..MaxFajta] of String=('ut','utca','krt.','ter','dl');
    Var
      iK:Byte;
      fajta,
      hsz:String;
  Begin
    iK:=Random(MV+MK)+1; fajta:=Fajtak[Random(MaxFajta)]; Str(Random(100)+1,hsz);
    RandomCim:=Vezetek[iK]+' '+fajta+' '+hsz;
  End;

  Function RandomTel: TNev;
    Var tsz:String;
        i:Byte;
  Begin
    tsz:='';
    For i:=1 to 6 do tsz:=tsz+Chr(Random(10)+Ord('0'));
    tsz:=Chr(Random(9)+Ord('1'))+tsz;
    RandomTel:=tsz;
  End;

  Function RandomSzemSzam(nem:Char{1. jel}): TNev; {1900-1999 kozott szuletettekhez}
    Var s,sz:String;
        k,ho,nap:Integer;
  Begin
    {Nem:}
    sz:=nem;
    {v:}
    sz:=sz+Chr(Random(10)+Ord('0')); sz:=sz+Chr(Random(10)+Ord('0'));
    {h:}
    ho:=Random(12)+1; Str(ho,s); s:='0'+s;
    sz:=sz+Copy(s,Length(s)-1,2);
    {nap:}
    Case ho of
      2              : nap:=28;
      1,3,5,7,8,10,12: nap:=31;
      4,6,9,11       : nap:=30;
    End;
    nap:=Random(nap)+1; Str(nap,s); s:='0'+s;
    sz:=sz+Copy(s,Length(s)-1,2);
    {Kontrolszm:}
    k:=Random(9998)+1; Str(k,s); s:='000'+s;
    sz:=sz+Copy(s,Length(s)-3,4);
    RandomSzemSzam:=sz;
  End;
